package cn.gygxzc.cloud.tina.fastdfs.client.controller;

import com.github.tobato.fastdfs.proto.storage.DownloadCallback;
import com.github.tobato.fastdfs.service.FastFileStorageClient;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

/**
 * Created by niantuo on 2018/10/29.
 * 文件下载或者说是
 */
@Controller
@RequestMapping("/files")
public class FdfsDownloadController {

    @Autowired
    private FastFileStorageClient storageClient;

    @RequestMapping("/{group}/{path}")
    public void download(@PathVariable("group") String group, @PathVariable("path") String path, HttpServletResponse response) {
        InputStream inputStream = null;
        OutputStream outputStream = null;
        try {
            inputStream = storageClient.downloadFile(group, path, ins -> ins);
            outputStream = response.getOutputStream();
            byte[] bytes = new byte[1024];
            while ((inputStream.read(bytes)) != -1) {
                outputStream.write(bytes, 0, bytes.length);
            }
            response.flushBuffer();
        } catch (IOException e) {
            throw new RuntimeException("文件下载失败，请重试。");
        } finally {
            if (inputStream != null) {
                try {
                    inputStream.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            if (outputStream != null) {
                try {
                    outputStream.flush();
                    outputStream.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }

            }
        }
    }

}
